import Vue from "vue/dist/vue";
import Vuex from "vuex";
import undoRedo, {
  scaffoldState,
  scaffoldActions,
  scaffoldMutations
} from "undo-redo-vuex";
import cloneDeep from "clone-deep";
import mutations from "./mutations";
import actions from "./actions";

Vue.use(Vuex);

export default state =>
  new Vuex.Store({
    plugins: [undoRedo()],
    state: scaffoldState(state),
    actions: scaffoldActions(actions),
    mutations: scaffoldMutations(mutations(cloneDeep(state)))
  });
